Attribute VB_Name = "declModule"
Option Explicit

Public Enum colorsequencesettings
redimcolor8 = 0
redimcolor16 = 1
redimcolor35 = 2
redimcolors = 3
adddelcolors = 4
colorgrad = 5
savecolorsset = 6
addsavedcolorsset = 7
clonecolors = 8
segment = 9
beginrotation = 10
rotatecolorset = 11
doublecolor = 12
redimcolor1 = 13
coloramountn = 14
sumsavedcolorsset = 16
End Enum

'Operation modes
Public Const sequentialmode = 0
Public Const concentricmode = 1
Public Const manualmode = 2
Public Const picturemode = 3
Public Const curvesmode = 4
Public Const pixelmode = 5


Public Const areaselectmode = 6



Public Declare Function CreateImgen Lib "imagen.dll" () As Long
Public Declare Sub DestroyImgen Lib "imagen.dll" ()

Public Declare Function generate Lib "imagen.dll" () As Integer
Public Declare Sub linebuilding Lib "imagen.dll" (ByVal i As Long)
Public Declare Function resultX Lib "imagen.dll" (ByVal i As Long) As Long
Public Declare Function resultY Lib "imagen.dll" (ByVal i As Long) As Long
Public Declare Function resultColor Lib "imagen.dll" (ByVal i As Long) As Long
Public Declare Function resultWidth Lib "imagen.dll" () As Long
Public Declare Function amountoflines Lib "imagen.dll" () As Long
Public Declare Function linelength Lib "imagen.dll" () As Long
Public Declare Function numberofcolors Lib "imagen.dll" () As Long
Public Declare Function colorsequence Lib "imagen.dll" (ByVal i As Long) As Long
Public Declare Function widthsequence Lib "imagen.dll" (ByVal i As Long) As Long
Public Declare Function transpsequence Lib "imagen.dll" (ByVal i As Long) As Long

Public Declare Sub colorsetting Lib "imagen.dll" (ByVal ftype As Long, ByVal p0 As Long, ByVal p1 As Long, ByVal p2 As Long, ByVal p3 As Long, ByVal p4 As Long, ByVal p5 As Single)
Public Declare Sub widthsetting Lib "imagen.dll" (ByVal ftype As Long, ByVal p0 As Long, ByVal p1 As Long, ByVal p2 As Long, ByVal p3 As Long, ByVal p4 As Long, ByVal p5 As Single)
Public Declare Sub transpsetting Lib "imagen.dll" (ByVal ftype As Long, ByVal p0 As Long, ByVal p1 As Long, ByVal p2 As Long, ByVal p3 As Long, ByVal p4 As Long, ByVal p5 As Single)



Public Declare Function datageneration Lib "imagen.dll" (ByVal contup As Long, ByVal contleft As Long, ByVal numblines As Long, _
 ByVal logicalX As Long, ByVal logicalY As Long, ByVal offsetlogicalX As Long, ByVal offsetlogicalY As Long, _
 ByVal Operationmode As Long, ByVal funcs As Long, ByVal modeparam1 As Long, ByVal modeparam2 As Long, _
 ByVal shapes As Long, ByVal shapes1 As Long, ByVal shpparam1 As Long, ByVal shpparam2 As Long, ByVal shpparam3 As Long, _
 ByVal shpar1 As Long, ByVal shpar2 As Long, ByVal shpar3 As Long, _
 ByVal orientxy As Long, ByVal povorxy As Long, ByVal Alpha As Long, _
 ByVal prospect As Long, ByVal destort As Long, _
 ByVal outlinepercent As Long, ByVal outlproportion As Long, _
 ByVal chlinecol As Long, ByVal linelength As Long, _
 ByVal linecolorfunc As Long, ByVal chsetcolors As Long, ByVal spiralmode As Long, _
 ByVal spiralparam1 As Long, ByVal spiralparam2 As Long, ByVal spiralmode1 As Long, _
 ByVal pixred As Long, ByVal pixblue As Long, ByVal pixgreen As Long, _
 ByRef manualpoints As Long, ByVal manuallength As Long, _
 ByRef handdrborder As Long, ByVal handdrlength As Long, ByVal callbackproga As Long) As Long

Public Declare Function areaselection Lib "imagen.dll" (ByVal fPic11hDC1 As Long, _
ByVal modebord As Long, _
ByVal tolerance As Long, ByVal x As Long, ByVal y As Long, _
ByVal Brightness As Long, ByVal Intencity As Long, ByVal Hue As Long, _
ByVal rcomp As Long, ByVal gcomp As Long, ByVal bcomp As Long, _
ByVal BackColor As Long) As Long

Public Declare Function transformation Lib "imagen.dll" (ByVal fPic11hDC1 As Long, ByVal mode As Long, _
ByVal shapes As Long, ByVal shpparam1 As Long, ByVal shpparam2 As Long, _
ByVal shpparam3 As Long, ByVal shapes1 As Long, ByVal shpar1 As Long, _
ByVal shpar2 As Long, ByVal shpar3 As Long, ByVal destort As Long, _
ByVal orientxy As Long, ByVal povorxy As Long, ByVal prospect As Long, _
ByRef handdrborder As Long, ByVal handdrlength As Long) As Long

Public Declare Function pixeldraw Lib "imagen.dll" (ByVal fPic11hDC1 As Long, _
ByVal a1 As Long, ByVal a2 As Long, ByVal a3 As Long) As Long

Public Declare Function intersections Lib "imagen.dll" (ByVal linenumber As Long) As Long




'rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
'ggggggggggggggggggggggggggggggggggggggggggggggggg





Public Type POINTL    ' aka Point
   x As Long
   y As Long
End Type
Public Type POINTF   ' aka PointF
   x As Single
   y As Single
End Type

Public Type RECTL     ' aka Rect
   Left As Long
   Top As Long
   Width As Long
   Height As Long
End Type

Public Type RECTF     ' aka Rect
   Left As Single
   Top As Single
   Width As Single
   Height As Single
End Type





Public Enum CombineMode
   CombineModeReplace      ' 0
   CombineModeIntersect    ' 1
   CombineModeUnion        ' 2
   CombineModeXor          ' 3
   CombineModeExclude      ' 4
   CombineModeComplement   ' 5 (Exclude From)
End Enum
' Various Hatch Styles
Public Enum HatchStyle
   HatchStyleHorizontal                   ' 0
   HatchStyleVertical                     ' 1
   HatchStyleForwardDiagonal              ' 2
   HatchStyleBackwardDiagonal             ' 3
   HatchStyleCross                        ' 4
   HatchStyleDiagonalCross                ' 5
   HatchStyle05Percent                    ' 6
   HatchStyle10Percent                    ' 7
   HatchStyle20Percent                    ' 8
   HatchStyle25Percent                    ' 9
   HatchStyle30Percent                    ' 10
   HatchStyle40Percent                    ' 11
   HatchStyle50Percent                    ' 12
   HatchStyle60Percent                    ' 13
   HatchStyle70Percent                    ' 14
   HatchStyle75Percent                    ' 15
   HatchStyle80Percent                    ' 16
   HatchStyle90Percent                    ' 17
   HatchStyleLightDownwardDiagonal        ' 18
   HatchStyleLightUpwardDiagonal          ' 19
   HatchStyleDarkDownwardDiagonal         ' 20
   HatchStyleDarkUpwardDiagonal           ' 21
   HatchStyleWideDownwardDiagonal         ' 22
   HatchStyleWideUpwardDiagonal           ' 23
   HatchStyleLightVertical                ' 24
   HatchStyleLightHorizontal              ' 25
   HatchStyleNarrowVertical               ' 26
   HatchStyleNarrowHorizontal             ' 27
   HatchStyleDarkVertical                 ' 28
   HatchStyleDarkHorizontal               ' 29
   HatchStyleDashedDownwardDiagonal       ' 30
   HatchStyleDashedUpwardDiagonal         ' 31
   HatchStyleDashedHorizontal             ' 32
   HatchStyleDashedVertical               ' 33
   HatchStyleSmallConfetti                ' 34
   HatchStyleLargeConfetti                ' 35
   HatchStyleZigZag                       ' 36
   HatchStyleWave                         ' 37
   HatchStyleDiagonalBrick                ' 38
   HatchStyleHorizontalBrick              ' 39
   HatchStyleWeave                        ' 40
   HatchStylePlaid                        ' 41
   HatchStyleDivot                        ' 42
   HatchStyleDottedGrid                   ' 43
   HatchStyleDottedDiamond                ' 44
   HatchStyleShingle                      ' 45
   HatchStyleTrellis                      ' 46
   HatchStyleSphere                       ' 47
   HatchStyleSmallGrid                    ' 48
   HatchStyleSmallCheckerBoard            ' 49
   HatchStyleLargeCheckerBoard            ' 50
   HatchStyleOutlinedDiamond              ' 51
   HatchStyleSolidDiamond                 ' 52
   HatchStyleTotal
   HatchStyleLargeGrid = HatchStyleCross  ' 4
   HatchStyleMin = HatchStyleHorizontal
   HatchStyleMax = HatchStyleTotal - 1
End Enum


Public Enum DashStyle
   DashStyleSolid          ' 0
   DashStyleDash           ' 1
   DashStyleDot            ' 2
   DashStyleDashDot        ' 3
   DashStyleDashDotDot     ' 4
   DashStyleCustom         ' 5
End Enum

Public Enum TextRenderingHint
   TextRenderingHintSystemDefault = 0            ' Glyph with system default rendering hint
   TextRenderingHintSingleBitPerPixelGridFit     ' Glyph bitmap with hinting
   TextRenderingHintSingleBitPerPixel            ' Glyph bitmap without hinting
   TextRenderingHintAntiAliasGridFit             ' Glyph anti-alias bitmap with hinting
   TextRenderingHintAntiAlias                    ' Glyph anti-alias bitmap without hinting
   TextRenderingHintClearTypeGridFit              ' Glyph CT bitmap with hinting
End Enum


Public Enum GpStatus   ' aka Status
   Ok = 0
   GenericError = 1
   InvalidParameter = 2
   OutOfMemory = 3
   ObjectBusy = 4
   InsufficientBuffer = 5
   NotImplemented = 6
   Win32Error = 7
   WrongState = 8
   Aborted = 9
   FileNotFound = 10
   ValueOverflow = 11
   AccessDenied = 12
   UnknownImageFormat = 13
   FontFamilyNotFound = 14
   FontStyleNotFound = 15
   NotTrueTypeFont = 16
   UnsupportedGdiplusVersion = 17
   GdiplusNotInitialized = 18
   PropertyNotFound = 19
   PropertyNotSupported = 20
End Enum
' Quality mode constants
Public Enum QualityMode
   QualityModeInvalid = -1
   QualityModeDefault = 0
   QualityModeLow = 1       ' Best performance
   QualityModeHigh = 2       ' Best rendering quality
End Enum



Public Enum BrushType
   BrushTypeSolidColor = 0
   BrushTypeHatchFill = 1
   BrushTypeTextureFill = 2
   BrushTypePathGradient = 3
   BrushTypeLinearGradient = 4
End Enum

Public Enum CompositingQuality
   CompositingQualityInvalid = QualityModeInvalid
   CompositingQualityDefault = QualityModeDefault
   CompositingQualityHighSpeed = QualityModeLow
   CompositingQualityHighQuality = QualityModeHigh
   CompositingQualityGammaCorrected
   CompositingQualityAssumeLinear
End Enum

Public Enum InterpolationMode
   InterpolationModeInvalid = QualityModeInvalid
   InterpolationModeDefault = QualityModeDefault
   InterpolationModeLowQuality = QualityModeLow
   InterpolationModeHighQuality = QualityModeHigh
   InterpolationModeBilinear
   InterpolationModeBicubic
   InterpolationModeNearestNeighbor
   InterpolationModeHighQualityBilinear
   InterpolationModeHighQualityBicubic
End Enum

Public Enum SmoothingMode
   SmoothingModeInvalid = QualityModeInvalid
   SmoothingModeDefault = QualityModeDefault
   SmoothingModeHighSpeed = QualityModeLow
   SmoothingModeHighQuality = QualityModeHigh
   SmoothingModeNone
   SmoothingModeAntiAlias
End Enum

' Various wrap modes for brushes
Public Enum WrapMode
   WrapModeTile         ' 0
   WrapModeTileFlipX    ' 1
   WrapModeTileFlipy    ' 2
   WrapModeTileFlipXY   ' 3
   WrapModeClamp        ' 4
End Enum

Public Enum GpUnit  ' aka Unit
   UnitWorld      ' 0 -- World coordinate (non-physical unit)
   UnitDisplay    ' 1 -- Variable -- for PageTransform only
   UnitPixel      ' 2 -- Each unit is one device pixel.
   UnitPoint      ' 3 -- Each unit is a printer's point, or 1/72 inch.
   UnitInch       ' 4 -- Each unit is 1 inch.
   UnitDocument   ' 5 -- Each unit is 1/300 inch.
   UnitMillimeter ' 6 -- Each unit is 1 millimeter.
End Enum

Public Enum LinearGradientMode
   LinearGradientModeHorizontal          ' 0
   LinearGradientModeVertical            ' 1
   LinearGradientModeForwardDiagonal     ' 2
   LinearGradientModeBackwardDiagonal    ' 3
End Enum
Public Enum PenType
   PenTypeSolidColor = BrushTypeSolidColor
   PenTypeHatchFill = BrushTypeHatchFill
   PenTypeTextureFill = BrushTypeTextureFill
   PenTypePathGradient = BrushTypePathGradient
   PenTypeLinearGradient = BrushTypeLinearGradient
   PenTypeUnknown = -1
End Enum
' Common color constants
' NOTE: Oringinal enum was unnamed


' Custom types
Public Type COLORBYTES
   BlueByte As Byte
   GreenByte As Byte
   RedByte As Byte
   AlphaByte As Byte
End Type
Public Type COLORLONG
   longval As Long
End Type

Public Enum ColorChannels
    ixcBlack = 0
    ixcRED = 1
    ixcGREEN = 2
    ixcYellow = 3
    ixcBLUE = 4
    ixcMagenta = 5
    ixcCyan = 6
    ixcAll = 7
    ixcWhite = 7
End Enum



Public Declare Function GdiplusStartup Lib "gdiplus" (token As Long, inputbuf As GdiplusStartupInput, Optional ByVal outputbuf As Long = 0) As GpStatus
Public Declare Sub GdiplusShutdown Lib "gdiplus" (ByVal token As Long)
'Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
    lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)
Public Declare Function VarPtrArray Lib "msvbvm60.dll" Alias "VarPtr" (Ptr() As Any) As Long
Public Declare Function lstrlenW Lib "kernel32" (ByVal lpString As Long) As Long

Public Declare Function GdipLoadImageFromFile Lib "gdiplus" (ByVal Filename As String, image As Long) As GpStatus

Public Declare Function CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Dest As Any, src As Any, ByVal cB As Long) As Long
'Public Declare Function GdipBitmapLockBits Lib "gdiplus" (ByVal BITMAP As Long, rect As RECTL, ByVal Flags As ImageLockMode, ByVal PixelFormat As Long, lockedBitmapData As BitmapData) As GpStatus
Public Declare Function GdipCreateBitmapFromHBITMAP Lib "gdiplus" (ByVal hbm As Long, ByVal hPal As Long, BITMAP As Long) As GpStatus
Public Declare Function GdipGetImageWidth Lib "gdiplus" (ByVal image As Long, Width As Long) As GpStatus
Public Declare Function GdipGetImageHeight Lib "gdiplus" (ByVal image As Long, Height As Long) As GpStatus

Public Declare Function GdipGetImageGraphicsContext Lib "gdiplus" (ByVal image As Long, graphics As Long) As GpStatus
Public Declare Function GdipCreateBitmapFromGraphics Lib "gdiplus" (ByVal Width As Long, ByVal Height As Long, ByVal graphics As Long, BITMAP As Long) As GpStatus
'Public Declare Function GdipDeleteGraphics Lib "gdiplus" (ByVal graphics As Long) As GpStatus
Public Declare Function GdipSetInterpolationMode Lib "gdiplus" (ByVal graphics As Long, ByVal interpolation As InterpolationMode) As GpStatus

Public Declare Function GdipCreateRegionPath Lib "gdiplus" (ByVal path As Long, region As Long) As GpStatus
'Public Declare Function GdipSetClipRegion Lib "gdiplus" (ByVal graphics As Long, ByVal region As Long, ByVal CombineMd As CombineMode) As GpStatus
'Public Declare Function GdipDrawImageI Lib "gdiplus" (ByVal graphics As Long, ByVal image As Long, ByVal x As Long, ByVal y As Long) As GpStatus
Public Declare Function GdipDrawImageRectI Lib "gdiplus" (ByVal graphics As Long, ByVal image As Long, ByVal x As Long, ByVal y As Long, ByVal Width As Long, ByVal Height As Long) As GpStatus
Public Declare Function GdipDeleteRegion Lib "gdiplus" (ByVal region As Long) As GpStatus


Public Declare Function GdipCreatePath Lib "gdiplus" (ByVal brushmode As FillMode, path As Long) As GpStatus
Public Declare Function GdipAddPathRectangle Lib "gdiplus" (ByVal path As Long, ByVal x As Single, ByVal y As Single, ByVal Width As Single, ByVal Height As Single) As GpStatus
Public Declare Function GdipAddPathRectangles Lib "gdiplus" (ByVal path As Long, rect As RECTF, ByVal count As Long) As GpStatus
Public Declare Function GdipAddPathEllipse Lib "gdiplus" (ByVal path As Long, ByVal x As Single, ByVal y As Single, ByVal Width As Single, ByVal Height As Single) As GpStatus
Public Declare Function GdipAddPathPolygonI Lib "gdiplus" (ByVal path As Long, Points As POINTL, ByVal count As Long) As GpStatus
Public Declare Function GdipAddPathLineI Lib "gdiplus" (ByVal path As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As GpStatus
Public Declare Function GdipSetCompositingQuality Lib "gdiplus" (ByVal graphics As Long, ByVal CompositingQlty As CompositingQuality) As GpStatus
Public Declare Function GdipSetSmoothingMode Lib "gdiplus" (ByVal graphics As Long, ByVal SmoothingMd As SmoothingMode) As GpStatus
Public Declare Function GdipCreateFromHDC Lib "gdiplus" (ByVal hDC As Long, graphics As Long) As GpStatus
Public Declare Function GdipCreatePen1 Lib "gdiplus" (ByVal Color As Long, ByVal Width As Single, ByVal unit As GpUnit, pen As Long) As GpStatus
Public Declare Function GdipCreatePen2 Lib "gdiplus" (ByVal Brush As Long, ByVal Width As Single, ByVal unit As GpUnit, pen As Long) As GpStatus
Public Declare Function GdipCreateLineBrushFromRect Lib "gdiplus" (rect As RECTF, ByVal color1 As Long, ByVal color2 As Long, ByVal mode As LinearGradientMode, ByVal WrapMd As WrapMode, lineGradient As Long) As GpStatus
Public Declare Function GdipSetLineGammaCorrection Lib "gdiplus" (ByVal Brush As Long, ByVal useGammaCorrection As Long) As GpStatus
Public Declare Function GdipDeleteBrush Lib "gdiplus" (ByVal Brush As Long) As GpStatus
Public Declare Function GdipSetPathGradientCenterColor Lib "gdiplus" (ByVal Brush As Long, ByVal lColors As Long) As GpStatus
Public Declare Function GdipSetPathGradientSurroundColorsWithCount Lib "gdiplus" (ByVal Brush As Long, argb As Long, count As Long) As GpStatus
Public Declare Function GdipSetPathGradientFocusScales Lib "gdiplus" (ByVal Brush As Long, ByVal xScale As Single, ByVal yScale As Single) As GpStatus
Public Declare Function GdipCreateTexture Lib "gdiplus" (ByVal image As Long, ByVal WrapMd As WrapMode, Texture As Long) As GpStatus
Public Declare Function GdipCreateHatchBrush Lib "gdiplus" (ByVal style As HatchStyle, ByVal forecolr As Long, ByVal backcolr As Long, Brush As Long) As GpStatus
'p 'ublic Declare Function GdipCreateAdjustableArrowCap Lib "gdiplus" (ByVal Height As Single, ByVal Width As Single, ByVal isFilled As Long, cap As Long) As GpStatus

Public Declare Function GdipSetPenDashStyle Lib "gdiplus" (ByVal pen As Long, ByVal dStyle As DashStyle) As GpStatus
Public Declare Function GdipDrawPath Lib "gdiplus" (ByVal graphics As Long, ByVal pen As Long, ByVal path As Long) As GpStatus
Public Declare Function GdipDeletePen Lib "gdiplus" (ByVal pen As Long) As GpStatus
Public Declare Function GdipDeleteGraphics Lib "gdiplus" (ByVal graphics As Long) As GpStatus
Public Declare Function GdipCreatePathGradientFromPath Lib "gdiplus" (ByVal path As Long, polyGradient As Long) As GpStatus
Public Declare Function GdipDisposeImage Lib "gdiplus" (ByVal image As Long) As GpStatus
Public Declare Function GdipAddPathLine2I Lib "gdiplus" (ByVal path As Long, Points As POINTL, ByVal count As Long) As GpStatus
Public Declare Function GdipSetPathGradientCenterPointI Lib "gdiplus" (ByVal Brush As Long, Points As POINTL) As GpStatus
'Public Declare Function GdipSetPathGradientPresetBlend Lib "gdiplus" (ByVal Brush As Long, blend As Long, positions As Single, ByVal count As Long) As GpStatus
Public Declare Function GdipDeletePath Lib "gdiplus" (ByVal path As Long) As GpStatus

Public Declare Function GdipCreateSolidFill Lib "gdiplus" (ByVal argb As Long, Brush As Long) As GpStatus

Public Declare Function GdipFillPath Lib "gdiplus" (ByVal graphics As Long, ByVal Brush As Long, ByVal path As Long) As GpStatus

Public Declare Function GdipCreateBitmapFromScan0 Lib "gdiplus" (ByVal Width As Long, ByVal Height As Long, ByVal stride As Long, ByVal PixelFormat As Long, scan0 As Any, BITMAP As Long) As GpStatus


Declare Function SetRect Lib "user32" (lpRect As rect, ByVal X1 As Long, ByVal Y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As Long

Declare Function IsRectEmpty Lib "user32" (lpRect As rect) As Long
'Declare Function EqualRect Lib "user32" (lpRect1 As rect, lpRect2 As rect) As Long
Declare Function PtInRect Lib "user32" (lpRect As rect, ByVal ptx As Long, ByVal pty As Long) As Long
'Declare Function GetDesktopWindow Lib "user32" () As Long
Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long


Declare Function BitBlt Lib "gdi32" ( _
    ByVal hDestDC As Long, _
    ByVal x As Long, ByVal y As Long, _
    ByVal nWidth As Long, ByVal nHeight As Long, _
    ByVal hSrcDC As Long, _
    ByVal xSrc As Long, ByVal ySrc As Long, _
    ByVal dwRop As Long _
    ) As Long
Declare Function SetBkColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long
Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hDC As Long) As Long
Public Declare Function LineTo& Lib "gdi32" (ByVal hDC As Long, ByVal x2 As Long, ByVal y2 As Long)
Public Declare Function MoveToEx& Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, oldPoint As POINTAPI)
Public Declare Function Rectangle& Lib "gdi32" (ByVal hDC As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal x2 As Long, ByVal y2 As Long)
Public Declare Function SetGraphicsMode& Lib "gdi32" (ByVal hDC As Long, ByVal iMode As Long)
Public Declare Function ellipse Lib "gdi32" Alias "Ellipse" (ByVal hDC As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As Long

Public Declare Function CreatePen& Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long)
Public Declare Function SelectObject& Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long)
Public Declare Function DeleteObject& Lib "gdi32" (ByVal hObject As Long)
Public Declare Function SaveDC& Lib "gdi32" (ByVal hDC As Long)
Public Declare Function RestoreDC& Lib "gdi32" (ByVal hDC As Long, ByVal nSavedDC As Long)

Public Declare Function PaintRgn& Lib "gdi32" (ByVal hDC As Long, ByVal hRgn As Long)
Public Declare Function CombineRgn& Lib "gdi32" (ByVal hDest As Long, ByVal hSrc1 As Long, ByVal hsrc2 As Long, ByVal fHow As Long)
Public Declare Function CreateEllipticRgn& Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal x2 As Long, ByVal y2 As Long)
Public Declare Function CreatePolygonRgn& Lib "gdi32" (lpPoint As POINTAPI, ByVal nCount As Long, ByVal nPolyFillMode As Long)
Public Declare Function CreatePolyPolygonRgn& Lib "gdi32" (lpPoint As POINTAPI, lpPolyCounts As Long, ByVal nCount As Long, ByVal nPolyFillMode As Long)
Public Declare Function CreateRectRgn& Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal x2 As Long, ByVal y2 As Long)
Public Declare Function CreateRoundRectRgn& Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal x2 As Long, ByVal y2 As Long, ByVal x3 As Long, ByVal y3 As Long)
'Public Declare Function FrameRgn& Lib "gdi32" (ByVal hDC As Long, ByVal hRgn As Long, ByVal hBrush As Long, ByVal nWidth As Long, ByVal nHeight As Long)
Public Declare Function SelectClipRgn& Lib "gdi32" (ByVal hDC As Long, ByVal hRgn As Long)
Public Declare Function PtInRegion& Lib "gdi32" (ByVal hRgn As Long, ByVal x As Long, ByVal y As Long)
'Public Declare Function Polygon Lib "gdi32" (ByVal hDC As Long, lpPoints As Any, ByVal nCount As Long) As Long
Public Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
'Public Declare Function FillRgn Lib "gdi32" (ByVal hDC As Long, ByVal hRgn As Long, ByVal hBrush As Long) As Long
Public Declare Function BeginPath& Lib "gdi32" (ByVal hDC As Long)
Public Declare Function EndPath& Lib "gdi32" (ByVal hDC As Long)

Public Declare Function AdjustWindowRect& Lib "user32" (lpRect As rect, ByVal dwStyle As Long, ByVal bMenu As Long)
'Public Declare Function AdjustWindowRectEx& Lib "user32" (lpRect As rect, ByVal dsStyle As Long, ByVal bMenu As Long, ByVal dwEsStyle As Long)
Public Declare Function GetWindowLong& Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long)
'Public Declare Function SetWindowLong& Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long)
Public Declare Function StretchBlt Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
'Public Declare Function PatBlt Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal dwRop As Long) As Long
Public Declare Function MoveWindow& Lib "user32" (ByVal hwnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long)
Public Declare Function SelectClipPath& Lib "gdi32" (ByVal hDC As Long, ByVal iMode As Long)
Public Declare Function GetClipRgn& Lib "gdi32" (ByVal hDC As Long, ByVal hRgn As Long)
Public Declare Function GetClipBox Lib "gdi32" (ByVal hDC As Long, lpRect As rect) As Long
Public Declare Function SetPixel Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Public Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long) As Long

Public Declare Function GetRgnBox Lib "gdi32" (ByVal hRgn As Long, lpRect As rect) As Long
'**********************************

Public Declare Function GetClientRect& Lib "user32" (ByVal hwnd As Long, lpRect As rect)


Public Type GdiplusStartupInput
   GdiplusVersion As Long              ' Must be 1 for GDI+ v1.0, the current version as of this writing.
   DebugEventCallback As Long          ' Ignored on free builds
   SuppressBackgroundThread As Long    ' FALSE unless you're prepared to call
                                      ' the hook/unhook functions properly
  SuppressExternalCodecs As Long      ' FALSE unless you want GDI+ only to use
                                       ' its internal image codecs.
End Type


Public Enum FillMode
   FillModeAlternate        ' 0
   FillModeWinding           ' 1
End Enum



Public Type rect
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Public Type POINTAPI
        x As Long
        y As Long
End Type

Public Type size
    cX As Long
    cY As Long
End Type


Public Type PictureXY
Picture As StdPicture
Width As Long
Height As Long
End Type



Public Type setings
  contup As Long '   
  contleft As Long '   
  
  numblines As Long ' 
  EndZicle As Long

  DrawWidt As Long
  Drmode As Long
  linelength As Long
  linestyle As Long
  linestyleborder As Long
  
  capsend As Long
  capsbegin As Long
  capswi As Long
  capshe As Long
  
  brushgradparam1 As Double
  brushgradparam2 As Double
  BrushTypeFill As Long 'gdinit parameter
  BrushTypeOutline As Long 'gdinit parameter
  Clear As Long
  chlinecol As Long
  chsetcolors As Long
  fcolorgrad As Long
  linecolorfunc As Long
  picBackColor As Long
  add1cololor As Long 'Boolean
  colorpanelfunc As Long
 
  outline As Long
  outlinepercent As Long
  outlproportion As Long
  
  'image and selection sizes
  widthimx As Long
  widthimy As Long
  logicalX As Long
  logicalY As Long
  offsetlogicalX As Long
  offsetlogicalY As Long
  'image and selection sizes
 
  Operationmode As Long 'funcz
  
  
  funcs As Long  'funcz
  modeparam1 As Long
  modeparam2 As Long
  
' shape parameters
  shapes As Long
  shapes1 As Long
  shpparam1 As Long
  shpparam2 As Long
  shpparam3 As Long
  shpar1 As Long
  shpar2 As Long
  shpar3 As Long
  destort As Long
  orientxy As Long
  povorxy As Long
  prospect As Long
  Alpha As Long
' shape
  
  alphacanal1 As Long 'trsansparent
  alphacanal2 As Long
  alphabordercanal1 As Long 'trsansparent
  alphabordercanal2 As Long
  
  Fill As Long
  
  borderwidth As Long '
  BorderMode As Boolean
  
  'curves parameters
  spiralmode As Long
  spiralmode1 As Long
  spiralparam1 As Long
  spiralparam2 As Long
  'curves parameters
  
  'pixel mode parameters
  pixred As Long
  pixblue As Long
  pixgreen As Long
  'pixel mode parameters

  antialiasing As Long
  antialiasingf As Long

End Type


Public gdinit As gdiinitial
Public sets As setings
Public handdrborder() As Long 'free border
Public manualpoints() As Long 'manual mode
  Public pathcoord() As POINTL 'outlineregion mouseform
   Public pathcoord1() As POINTL 'pathmassivcorrection or setpathmassiv kx ky
   Public pathsizes(1) As Long 'pathmassivcorrection selogicalx,selogicaly
   

Public linecoord() As Long 'befordrawline draw line

Public Const BLACK_PEN = 6
Public Const PS_SOLID = 0
Public Const FLOODFILLSURFACE = 1
Public Const normalscale = 1
'Public Const midlleofdistortion = 95
Public Const midlleofangle& = 180
'Public Const minimalost = 1 '    
'Public Const numbercolordisplay = 32 'color panel length
Public Const maxamountofcolors& = 90000 'color massiv lenght

'
'Public Const midlleofdistortion = 95
Public Const PI! = 3.14159265359
Public Const e! = 2.71828
Public Const pion180! = 0.01745329252
'Dim twopi!, piontwo! ' As Single
'alpha = 100
Public Const twopi! = 6.28318530718 ' 2 * pi
Public Const piontwo! = 1.570796326795 'pi / 2
Public Const g180onpi = 57.2958
Public Const detselection& = 6
Public Const maximumpointsselectiion = 90000
Public Const setcontup = 100

Public Const GM_ADVANCED& = 2

Public regionfiltrs As Long

Public Const HWND_TOPMOST = -1
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOSIZE = &H1

Const R2_COPYPEN& = 13
Public Const ALTERNATE = 1
Public Const WINDING = 2
Public Const RGN_AND = 1
Public Const RGN_COPY = 5
Public Const RGN_DIFF = 4
Public Const RGN_OR = 2
Public Const RGN_XOR = 3
Public Const SRCCOPY = &HCC0020
Public Const SRCPAINT = &HEE0086
Public Const GWL_STYLE = (-16)
Public Const CLR_INVALID = -1
Public Const DEFAULT_QUALITY = 0
Public Const DEFAULT_PITCH = 0
Public Const DEFAULT_CHARSET = 1
Public Const FF_DONTCARE = 0
''  DrawText() Format Flags


Public Const RMask& = &HFF  ', GMask&, Bmask&
Public Const GMask& = &HFF00&
Public Const BMask& = &HFF0000




Public Const amountbuttons = 15
Public Const textbutton = 23


'Public savedDC&

