

// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the IMGEN_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// IMGEN_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef IMAGEN_EXPORTS
#define IMAGEN_API __declspec(dllexport)
#else
	#pragma message("automatic link to imagen.LIB")
	#pragma comment(lib, "imagen.lib")
#define IMAGEN_API __declspec(dllimport)
#endif

typedef int (__stdcall *CompareFunction)(int a, int b);



class IMAGEN_API CImgen {


public:
	CImgen(void);

void linebuildingImgen(int i);

 int   resultXImgen(int i);
 int   resultYImgen(int i);
 int   resultColorImgen(int i);
 int   resultWidthImgen();
 int   amountoflinesImgen();
 int   linelengthImgen();
 int   numberofcolorsImgen();
 int   colorsequenceImgen(int i);
 int   widthsequenceImgen(int i);
 int   transpsequenceImgen(int i);
 int   intersectionsImgen( int linenumber);
void   colorsettingImgen(int ftype, int p0=0, int p1=0, int p2=0, int p3=0, int p4=0, float p5=0);
void   widthsettingImgen(int ftype, int p0=0, int p1=0, int p2=0, int p3=0, int p4=0, float p5=0);
void   transpsettingImgen(int ftype, int p0=0, int p1=0, int p2=0, int p3=0, int p4=0, float p5=0);


int areaselectionImgen(HDC fPic11hDC1,  
 int background, int tolerance, int x, int y, int Brightness, 
 int Intencity, int Hue, int rcomp, int gcomp, int bcomp, int BackColor);



 int transformationImgen(HDC fPic11hDC1, int mode,
int shapes,int shpparam1, int shpparam2, int shpparam3,
int shapes1,int shpar1, int shpar2, int shpar3,
int distort,int orientxy,int povorxy,int prospect,
int *handdrborder,int handdrlength);


int  datagenerationImgen(int contup, int contleft, int numblines, 
 int logicalX, int logicalY, int offsetlogicalX, int offsetlogicalY,
 int Operationmode, int funcs, int modeparam1, int modeparam2, 
 int shapes, int shapes1, 
 int shpparam1, int shpparam2, int shpparam3,
 int shpar1, int shpar2, int shpar3, 
 int orientxy, int povorxy, int alpha,
 int prospect, int distort, 
 int outlinepercent, int outlproportion, 
 int chlinecol, int linelength, 
 int linecolorfunc, int chsetcolors, 
 int curvemode, int curveparam1, int curveparam2, 
 int pixelmode, int pixred, int pixblue, int pixgreen,
  int *manualpoints,int manuallength,
 int *handdrborder,int handdrlength,CompareFunction cmpFunc);	
// TODO: add your methods here.
};	

//int __stdcall pixeldraw(HDC fPic11hDC1,HDC fPic11hDC2, int mode);
int IMAGEN_API pixeldrawImgen(HDC fPic11hDC1, int pixredcase, int pixbluecase,
int pixgreencase);



void * __stdcall CreateImgen();
void __stdcall DestroyImgen();
//int __stdcall generate(void * objptr);
void __stdcall linebuilding(int i);


int __stdcall resultX(int i);
int __stdcall resultY(int i);
int __stdcall resultColor(int i);
int __stdcall resultWidth();


int __stdcall amountoflines();
int __stdcall linelength();
int __stdcall numberofcolors();
int __stdcall colorsequence(int i);
int __stdcall widthsequence(int i);
int __stdcall transpsequence(int i);
void __stdcall colorsetting(int ftype, int p0=0, int p1=0, int p2=0, int p3=0, int p4=0, float p5=0);
void __stdcall widthsetting(int ftype, int p0=0, int p1=0, int p2=0, int p3=0, int p4=0, float p5=0);
void __stdcall transpsetting(int ftype, int p0=0, int p1=0, int p2=0, int p3=0, int p4=0, float p5=0);

int __stdcall datageneration(int contup, int contleft, int numblines, 
 int logicalX, int logicalY, int offsetlogicalX, int offsetlogicalY,
 int Operationmode, int funcs, int modeparam1, int modeparam2, 
 int shapes, int shapes1, int shpparam1, int shpparam2, int shpparam3,
 int shpar1, int shpar2, int shpar3, 
 int orientxy, int povorxy, int alpha,
 int prospect, int distort, 
 int outlinepercent, int outlproportion, 
 int chlinecol, int linelength, 
 int linecolorfunc, int chsetcolors,  
 int curvemode, int curveparam1, int curveparam2, 
 int pixelmode, int pixred, int pixblue, int pixgreen,
 int *manualpoints,int manuallength,
 int *handdrborder,int handdrlength,CompareFunction cmpFunc);


int __stdcall areaselection(HDC fPic11hDC1,  
 int background, int tolerance, int x, int y, int Brightness, 
 int Intencity, int Hue, int rcomp, int gcomp, int bcomp, int BackColor);


int __stdcall transformation(HDC fPic11hDC1,int mode,
int shapes,int shpparam1, int shpparam2, int shpparam3,
int shapes1,int shpar1, int shpar2, int shpar3,
int distort,int orientxy,int povorxy,int prospect,
int *handdrborder,int handdrlength);

//int __stdcall pixeldraw(HDC fPic11hDC1,HDC fPic11hDC2, int mode);
int __stdcall pixeldraw(HDC fPic11hDC1, int pixredcase, int pixbluecase,
int pixgreencase);

int __stdcall intersections( int linenumber);